var	Colors;
var	Ufo, Invader;
var	Slow;
var	Notes;

str.length(s) return t.memscan(s, 0, 32767);

str.copy(sd, ss) t.memcopy(ss, sd, str.length(ss)+1);

str.append(sd, ss) t.memcopy(ss, @sd::str.length(sd), str.length(ss)+1);

init() do var data;
	Slow := 1;
	Colors := [ "black", "blue", "green", "cyan", "red", "magenta",
		    "brown", "grey", "dark grey", "light blue",
		    "light green", "light cyan", "light red",
		    "light magenta", "yellow", "white" ];
	data := packed [ 0, 0x18, 0x7e, 0xdb, 0xff, 0x7e, 0x18, 0 ];
        Ufo := x.bitmap(8, 8, data);
	data := packed [ 0,    0,    0,    0, 0x30, 0x0c, 0x08, 0x10,
			 0x04, 0x20, 0x1f, 0xf8, 0x3f, 0xfc, 0x73, 0xce,
			 0xf3, 0xcf, 0xff, 0xff, 0xbf, 0xfd, 0xa0, 0x05,
			 0x10, 0x08, 0x0c, 0x30, 0,    0,    0,    0 ];
        Invader := x.bitmap(16, 16, data);
	Notes := [262, 294, 330, 349, 392, 440, 494, 523];

end

center(y, s) x.print(15-str.length(s)/2, y, s);

delay(x) if (Slow) x.delay(x);

wait(t) do var i;
	for (i=0, t) do
		if (Slow) delay(100);
		if (x.pressed(13)) leave;
		if (x.pressed('q')) halt 0;
	end
	x.clrscr();
end

title(s) do var i;
	x.bg(0);
	x.clrscr();
	x.fg(15);
	center(11, s);
	x.redraw();
	wait(20);
end

intro() do
	center(9, "xtcvm test program");
	center(11, "press ENTER to continue");
	center(13, "press q to quit");
	x.redraw();
	wait(70);
end

test.background() do var i;
	title("background colors");
	for (i=0, 16) do
		if (x.pressed(13)) return;
		if (x.pressed('q')) halt 0;
		x.bg(i);
		x.clrscr();
		x.redraw();
		delay(500);
	end
end

frame(x, y, dx, dy) do
	x.fg(15);
	x.line(x, y, dx, y);
	x.line(x, y, x, dy);
	x.line(dx, y, dx, dy);
	x.line(x, dy, dx, dy);
end

test.colors() do var i;
	title("foreground colors");
	for (i=0, 16) do
		x.fg(i);
		x.box(7+i*15, 50, 7+i*15+13, 150);
		frame(7+i*15, 50, 7+i*15+13, 150);
	end
	x.redraw();
	wait(50);
end

test.pixels() do var i;
	title("random pixels");
	for (i=0, 250) do
		if (x.pressed(13)) return;
		if (x.pressed('q')) halt 0;
		x.fg(9+x.rnd(7));
		x.point(x.rnd(256), x.rnd(192));
		x.redraw();
		delay(5);
	end
	wait(20);
end

test.lines() do var i;
	title("random lines");
	for (i=0, 250) do
		if (x.pressed(13)) return;
		if (x.pressed('q')) halt 0;
		x.fg(9+x.rnd(7));
		x.line(x.rnd(256), x.rnd(192), x.rnd(256), x.rnd(192));
		x.redraw();
		delay(10);
	end
	wait(20);
end

test.boxes() do var i;
	title("random boxes");
	for (i=0, 250) do
		if (x.pressed(13)) return;
		if (x.pressed('q')) halt 0;
		x.fg(9+x.rnd(7));
		x.box(x.rnd(256), x.rnd(192), x.rnd(256), x.rnd(192));
		x.redraw();
		delay(10);
	end
	wait(20);
end

test.charset() do var i, j;
	title("character set");
	for (j=0, 96, 16)
		for (i=0, 16)
			x.blit(8+i, 8+j/16, i+j);
	x.redraw();
	wait(50);
end

test.text() do var i, f, b, buf::100;
	title("printing text");
	for (i=2, 22) do
		if (x.pressed(13)) return;
		if (x.pressed('q')) halt 0;
		b := x.rnd(8);
		f := 8+x.rnd(8);
		str.copy(buf, Colors[f]);
		str.append(buf, " on ");
		str.append(buf, Colors[b]);
		x.bg(b);
		x.fg(f);
		x.print(5, i, buf);
		delay(100);
		x.redraw();
	end
	wait(50);
end

test.bitmaps() do var i;
	title("random bitmaps");
	for (i=0, 250) do
		if (x.pressed(13)) return;
		if (x.pressed('q')) halt 0;
		x.fg(9+x.rnd(7));
		x.blit(x.rnd(32), x.rnd(24), Ufo);
		x.redraw();
		delay(10);
	end
	x.clrscr();
	for (i=0, 250) do
		if (x.pressed(13)) return;
		if (x.pressed('q')) halt 0;
		x.fg(9+x.rnd(7));
		x.blit(2*x.rnd(16), 2*x.rnd(12), Invader);
		x.redraw();
		delay(10);
	end
	wait(20);
end

test.animation() do var i, x, y, dx, dy;
	title("bitmap animation");
	x := 15;
	y := 11;
	dx := 1;
	dy := 1;
	x.fg(14);
	for (i=0, 70) do
		if (x.pressed(13)) return;
		if (x.pressed('q')) halt 0;
		x.clear(x, y, Invader);
		x := x + dx;
		y := y + dy;
		x.blit(x, y, Invader);
		x.redraw();
		delay(100);
		if (x > 29) dx := %1;
		if (x < 1) dx := 1;
		if (y > 21) dy := %1;
		if (y < 1) dy := 1;
	end
	wait(10);
end

box(x, y, dx, dy) do var i, j;
	x.blit(x, y, 1);
	x.blit(dx, y, 2);
	x.blit(dx, dy, 3);
	x.blit(x, dy, 4);
	for (i=x+1, dx) do
		x.blit(i, y, 5);
		x.blit(i, dy, 5);
	end
	for (i=y+1, dy) do
		x.blit(x, i, 6);
		x.blit(dx, i, 6);
	end
	for (j=y+1, dy)
		for (i=x+1, dx)
			x.blit(i, j, 0);
end

var hbuf::3;
hex(x) do var d;
	d := "0123456789ABCDEF";

	hbuf::0 := d::(x/16);
	hbuf::1 := d::(x mod 16);
	hbuf::2 := 0;
	return hbuf;
end

test.screenmap() do var i, j, s;
	title("screen map");
	x.bg(2);
	x.fg(10);
	box(1, 10, 10, 14);
	x.print(2, 11, "hello");
	x.print(2, 12, "world");
	x.blit(8, 11, Invader);
	x.bg(0);
	x.fg(15);
	box(12, 10, 29, 14);
	x.redraw();
	for (j=11, 14) do
		for (i=0, j=11->7: j=13->8: 6) do
			if (x.pressed(13)) return;
			if (x.pressed('q')) halt 1;
			x.fg(0);
			x.bg(15);
			x.blit(2+i, j, x.screen(2+i, j));
			s := x.screen(2+i, j);
			x.print(13+i*2, j, hex(s));
			if (j=11 /\ i=6) do
				x.print(15+i*2, j, hex(s));
				x.print(13+i*2, j+1, hex(s));
				x.print(15+i*2, j+1, hex(s));
			end
			x.redraw();
			delay(300);
			x.fg(10);
			x.bg(2);
			x.blit(2+i, j, x.screen(2+i, j));
			x.redraw();
		end
	end
	wait(30);
end

test.scroll() do var i, j, x, y, d;
	title("scrolling");
	x.fg(10);
	d := 1;
	for (j=0, 2) do
		for (d=1, 5) do
			for (i=0, 20) do
				if (x.pressed(13)) return;
				if (x.pressed('q')) halt 0;
				ie (d = 1) do
					x.scroll(1);
					x.blit(x.rnd(32), 23, Ufo);
				end
				else ie (d = 2) do
					x.scroll(2);
					x.blit(31, x.rnd(24), Ufo);
				end
				else ie (d = 3) do
					x.scroll(3);
					x.blit(x.rnd(32), 0, Ufo);
				end
				else do
					x.scroll(4);
					x.blit(0, x.rnd(24), Ufo);
				end
				x.redraw();
				delay(100);
			end
		end
	end
	wait(10);
end

test.redraw() do var i, j, q[24];
	title("frame drawing");
	for (j=0, 24) q[j] := x.rnd(32);
	for (i=0, 100) do
		if (x.pressed(13)) return;
		if (x.pressed('q')) halt 0;
		x.bg(0);
		x.fg(10);
		x.clrscr();
		for (j=0, 24) x.blit(q[j], j, Ufo);
		x.bg(1);
		x.fg(13);
		box(8, 10, 22, 13);
		x.print(9, 11, "ufos passing");
		x.print(9, 12, "under the box");
		x.redraw();
		delay(100);
		for (j=0, 23) q[j] := q[j+1];
		q[23] := x.rnd(32);
	end
	wait(10);
end

test.sound() do var i, j, n;
	n := "CDEFGABC";
	title("sound");
	x.clrscr();
	x.wave(1);
	for (i=0, 8) do
		if (x.pressed(13)) return;
		if (x.pressed('q')) halt 0;
		x.blit(2*i+8, 10, n::i);
		x.redraw();
		if (Slow) x.beep(Notes[i], 250);
	end
	wait(20);
	if (Slow) do
		x.wave(0);
		x.clrscr();
		x.redraw();
		for (i=0, 5)
			for (j=440, 660, 55)
				x.beep(j, 50);
		x.fg(0);
		x.bg(12);
		center(10, "game over!");
		x.redraw();
		for (i=0, 50)
			for (j=660-i*5, 440-i*5, %55)
				x.beep(j, 5);
	end
	wait(20);
end

test.keys() do var i, go, x;
	if (\Slow) return;
	go := 0;
	title("keyboard input");
	x.clrscr();
	x.fg(0);
	x.bg(15);
	center(11, "press ENTER to start test");
	x.redraw();
	for (i=0, 50) do
		if (x.pressed(13)) do
			go := %1;
			leave;
		end
		delay(100);
	end
	if (\go) return;
	x.fg(15);
	x.bg(0);
	x.clrscr();
	center(10, "press ENTER any time");
	x.redraw();
	for (i=0, 20) x.blit(i+5, 12, 14);
	go := 0;
	for (i=0, 20) do
		if (x.pressed(13)) do
			go := %1;
			leave;
		end
		x.blit(i+5, 12, 16);
		x.redraw();
		delay(250);
	end
	x.fg(15);
	center(14, go-> "yep, pressed it": "nope, didn't press it");
	x.redraw();
	wait(30);
	x.clrscr();
	center(10, "Use <- and -> to move to UFO");
	center(12, "Press ENTER when done");
	x := 15;
	x.fg(11);
	while(1) do
		x.blit(x, 15, Ufo);
		x.redraw();
		delay(50);
		if (x.keydown(2) /\ x < 31) do
			x.clear(x, 15, Ufo);
			x := x+1;
		end
		if (x.keydown(4) /\ x > 0) do
			x.clear(x, 15, Ufo);
			x := x-1;
		end
		if (x.keydown(13)) leave;
	end
	x.fg(15);
	x.clrscr();
	center(11, "OK");
	x.redraw();
	while(x.pressed(13));
	wait(20);
end

run(x) do
	Slow := x;
	intro();
	test.background();
	test.colors();
	test.pixels();
	test.lines();
	test.boxes();
	test.charset();
	test.text();
	test.bitmaps();
	test.animation();
	test.screenmap();
	test.scroll();
	test.redraw();
	test.sound();
	test.keys();
end

interlude() do
	x.bg(0);
	x.clrscr();
	x.fg(14);
	x.fg(0);
	x.bg(14);
	center(10, "                ");
	center(11, " and once again ");
	center(12, "                ");
	center(13, " at full speed! ");
	center(14, "                ");
	x.redraw();
	wait(40);
end

fini() do
	x.clrscr();
	center(10, "that's all!");
	center(12, "press any key to exit");
	x.redraw();
	x.getkey();
end

do var i;
	x.init();
	init();
	run(1);
	interlude();
	run(0);
	fini();
	x.fini();
end
